<template>
  <v-container>
    
    <v-dialog
        v-model="withdrawSuccess"
        elevation="24"
        class="text-center"
        width="20%"
      >
        <img src="../assets/success_animation.gif" alt="success-animation">
      </v-dialog>
  
      <v-row justify="center">
      <v-dialog
        v-model="dialog"
        persistent
        max-width="600px"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-container>
          <v-row class="justify-end mt-5">
          <v-btn 
            color="info"
            dark
            v-bind="attrs"
            v-on="on"
            rounded
            large
          >
            <v-icon>Withdraw</v-icon>
          </v-btn>
      </v-row>
  </v-container>
        </template>
        <v-card>
          <v-card-title>
            <span class="text-h5">Abheben</span>
          </v-card-title>
          <v-card-text>
            <v-form>
            <v-container>
              <v-row>
                <!-- item-text liest den namen aus dem object. Aber keine Ahnung warum name in '' geschrieben werden muss-->
                <v-col cols="12">
                  <v-select
                  v-model="WithdrawDetails.space"
                  :items="allSpacesList"
                  :item-text="'name'"
                  :item-value="'id'"
                  name="name"
                  label="Space"
                  required
                  return-object
                ></v-select>
                <h3 v-show="this.WithdrawDetails.space.accountBalance">
                  €{{ this.WithdrawDetails.space.accountBalance }} Guthaben</h3>
                </v-col>
                <v-col cols="12">
                  <v-text-field
                    v-model="WithdrawDetails.personName"
                    label="Name des Empfängers"
                    required
                    :rules="nameRules"
                    :counter="30"
                  ></v-text-field>
                </v-col>
                <v-col cols="12">
                  <v-text-field
                  v-model="WithdrawDetails.email"
                    label="EMail"
                    required
                    :rules="emailRules"
                  ></v-text-field>
                </v-col>
                <v-col cols="12">
                  <v-text-field
                  v-model="WithdrawDetails.amount"
                    label="Betrag €"
                    required
                    type="number"
                    :rules="withdrawAmountRules"
                  ></v-text-field>
                </v-col>
                
                
              </v-row>
            </v-container>
          </v-form>
            <!-- <small>*indicates required field</small> -->
          </v-card-text>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn
              color="blue darken-1"
              text
              @click="dialog = false"
            >
              Zurück
            </v-btn>
            <v-btn
              color="blue darken-1"
              text
              @click="spaceWithdraw(), dialog = false"
            >
              Erstellen
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </v-row>
  </v-container>
  </template>
    
    <script>
  
      export default {
        name: 'PostSpace',
  
      props: {
            kontoIdProp: String,
        },
  
        data()  {
          return {
              dialog: false,
  
              kontoId: this.kontoIdProp,

              WithdrawDetails: {
                  space: {
                    accountBalance: "",
                    id: "",
                    name: "",
                    description: ""
                  },
                  amount: "",
                  email: "",
                  personName: ""
              },

              formSpaceDetails: {
                accountBalance: "",
                id: ""
              },
  
              withdrawSuccess: false,
  
              valid: false,
              firstname: '',
              lastname: '',
              nameRules: [
                v => !!v || 'Wird benötigt',
                v => v.length >= 2 || 'Muss mindestens 2 Zeichen haben!',
                v => v.length <= 30 || 'Darf nicht länger als 30 Zeichen haben!',
              ],
              email: '',
              emailRules: [
                v => !!v || 'Wird benötigt',
                v => /.+@.+/.test(v) || 'Muss ein @ Zeichen enthalten',
              ],
              withdrawAmountRules: [
                v => !!v || 'Wird benötigt',
                v => v <= this.WithdrawDetails.space.accountBalance || 'Zu wenig Guthaben!',
                v => v > 0 || 'Der Betrag muss größer 0 sein',
              ]
          
        }},
  
        computed: {
          postKontoDialogState() {
              return this.$store.state.postKontoDialog
          },

          allSpacesList() {
              return this.$store.state.allSpacesByKontoId.spaces
          }
        },
  
        mounted() {
          this.getAllSpacesByKontoId();
        },
  
        methods: {
          getAllSpacesByKontoId() {
          this.$store.dispatch("getAllSpaceByKontoId", this.kontoId);
        },

          async spaceWithdraw() {
            console.log(this.WithdrawDetails)
            
            var spaceWithdraw = {
              spaceId: "",
              amount: "",
              kontoId: ""
            }
            spaceWithdraw.spaceId = this.WithdrawDetails.space.id;
            spaceWithdraw.amount = this.WithdrawDetails.amount;
            spaceWithdraw.kontoId = this.kontoId;
            await this.$store.dispatch("spaceWithdraw", spaceWithdraw).then(() => {
              this.showWithdrawSuccess();
              // this.WithdrawDetails.amount = ""
              // this.WithdrawDetails.email = ""
              // this.WithdrawDetails.personName = ""
              // this.WithdrawDetails.space.id = ""
              // this.WithdrawDetails.space.accountBalance = ""
            })
            
          },

        
        showWithdrawSuccess() {
          this.withdrawSuccess = true;
          setTimeout(() => {
            this.withdrawSuccess = false;
            window.location.reload();
            }, 2500);
        },

          
        }
        
      }
    </script>
    